'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _kindOf = require('kind-of');

var _kindOf2 = _interopRequireDefault(_kindOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * The types that `kind-of` supports..
 *
 * @type {Array}
 */

const KIND_OF_TYPES = ['arguments', 'array', 'boolean', 'buffer', 'date', 'float32array', 'float64array', 'function', 'generatorfunction', 'int16array', 'int32array', 'int8array', 'map', 'null', 'number', 'object', 'regexp', 'set', 'string', 'symbol', 'uint16array', 'uint32array', 'uint8array', 'uint8clampedarray', 'undefined', 'weakmap', 'weakset'];

/**
 * The default types that Superstruct ships with.
 *
 * @type {Object}
 */

const TYPES = {
  any: value => value !== undefined,
  error: value => Object.prototype.toString.call(value) === '[object Error]'
};

KIND_OF_TYPES.forEach(type => {
  TYPES[type] = value => (0, _kindOf2.default)(value) === type;
});

/**
 * Export.
 *
 * @type {Object}
 */

exports.default = TYPES;